package sun.awt.windows;

import java.awt.Color;
import java.awt.Component;
import java.awt.FontMetrics;
import java.awt.Label;
import java.awt.Dimension;
import java.awt.peer.LabelPeer;

final class WLabelPeer extends WComponentPeer implements LabelPeer
{
    @Override
    public Dimension getMinimumSize() {
        FontMetrics fontMetrics = this.getFontMetrics(((Label)this.target).getFont());
        String text = ((Label)this.target).getText();
        if (text == null) {
            text = "";
        }
        return new Dimension(fontMetrics.stringWidth(text) + 14, fontMetrics.getHeight() + 8);
    }
    
    native void lazyPaint();
    
    @Override
    synchronized void start() {
        super.start();
        this.lazyPaint();
    }
    
    @Override
    public boolean shouldClearRectBeforePaint() {
        return false;
    }
    
    @Override
    public native void setText(String p0);
    
    @Override
    public native void setAlignment(int p0);
    
    WLabelPeer(Label label) {
        super(label);
    }
    
    @Override
    native void create(WComponentPeer p0);
    
    @Override
    void initialize() {
        Label label = (Label)this.target;
        String text = label.getText();
        if (text != null) {
            this.setText(text);
        }
        int alignment = label.getAlignment();
        if (alignment != 0) {
            this.setAlignment(alignment);
        }
        Color background = ((Component)this.target).getBackground();
        if (background != null) {
            this.setBackground(background);
        }
        super.initialize();
    }
}
